//#version unofficial MegaPov 0.7;  
// note: MegaPoV gives some strange effects on the pole pigments.
// adaption should be easy. Developed and tested with official PoVRay 3.1g

#ifdef (JupiterPreview)
   
#declare JuPreviewTorus = torus { 1,0.01 
                                pigment { rgb <1,1,1> } 
                                finish { diffuse 1 
                                         ambient 0}}
#declare Jupiter =
union
{
   sphere { <0,0,0>,1
           pigment { rgb <167/255, 149/255, 135/255> }
           finish { diffuse 1 }
   }
  
   object { JuPreviewTorus rotate x*-90 }
   object { JuPreviewTorus rotate x*-90 rotate y*45 }
   object { JuPreviewTorus rotate x*-90 rotate y*90 }
   object { JuPreviewTorus rotate x*-90 rotate y*(90+45) }

   object { JuPreviewTorus }
   object { JuPreviewTorus scale <0.866,1,0.866> translate y*0.5 }
   object { JuPreviewTorus scale <0.866,1,0.866> translate y*-0.5 }
  scale <1428.00,1355.00,1428.00>
}

#else

// adjust clock settings for various gas layers. NOTE: assignment to the 
// appropriate layer and direction is done automatically. Just define speeds here.
#declare JuClk = clock*360;
#declare JuRotVSlow = JuClk*0.05;
#declare JuRotSlow = JuClk*0.1;
#declare JuRotMed = JuClk*0.2;
#declare JuRotFast = JuClk*0.4;

// colours are obtained from a NON colour-enhanced pic of NASA
// so this is not the typical reddish jupiter but the "real" one

// cloud colours for the great red spot
#local JuGrfCol = array[4] { rgb <137/255, 113/255,  90/255>,
                             rgb <150/255, 127/255, 105/255>,
                             rgb <167/255, 149/255, 135/255>,
                             rgb <152/255, 151/255, 153/255>}

// cloud bands 2 and 5
#local JuCol2_5 = array[8] { rgb <117/255, 101/255,  87/255>,
                             rgb <137/255, 113/255,  90/255>,
                             rgb <150/255, 127/255, 105/255>,
                             rgb <151/255, 135/255, 121/255>,
                             rgb <167/255, 149/255, 135/255>,
                             rgb <182/255, 163/255, 149/255>,
                             rgb <179/255, 170/255, 166/255>,
                             rgb <201/255, 203/255, 210/255>}

// cloud band 1
#local JuCol1 = array[5] { rgb < 96/255, 102/255, 110/255>,
                           rgb <168/255, 166/255, 168/255>,
                           rgb <154/255, 165/255, 182/255>,
                           rgb <167/255, 173/255, 184/255>,
                           rgb <182/255, 195/255, 214/255> }

// cloud band 3
#local JuCol3 = array[8] { rgb < 96/255, 102/255, 110/255>,
                           rgb <108/255, 115/255, 126/255>,
                           rgb <120/255, 125/255, 133/255>,
                           rgb <136/255, 135/255, 135/255>,
                           rgb <150/255, 140/255, 135/255>,
                           rgb <155/255, 147/255, 141/255>,
                           rgb <141/255, 151/255, 166/255>,
                           rgb <151/255, 157/255, 167/255> }

// clouds on the poles
#declare JupiterPolePigment=
pigment
{
    bozo
    color_map
    {
        [0.0  JuCol3[0]]
        [0.08 JuCol3[1]]
        [0.1  JuCol3[2]]
        [0.2  JuCol3[3]]
        [0.4  JuCol3[4]]
        [0.6  JuCol3[3]]
        [0.7  JuCol3[4]]
        [0.8  JuCol3[5]]
        [0.85 JuCol3[6]]
        [0.9  JuCol3[7]]
        [0.95 JuCol3[7]]
    }              
    turbulence 0.4
    omega 0.3
    scale 0.007
}

// Zone 1
#declare JupiterZone01Pigment=
pigment
{
    bozo
    color_map
    {
      [0.1 JuCol1[1]]
      [0.2 JuCol1[2]]
      [0.6 JuCol1[3]]
      [0.9 JuCol1[4]]
    }              
    turbulence 0.4
    omega 0.8
    scale <0.4,0.01,1>
}

// Zone 2
#declare JupiterZone02Pigment=
pigment
{
    gradient y
    sine_wave
    scale <0.05,0.02,1>
    turbulence 0.7
    omega 0.6
    color_map
    {
      [0.00 JuCol2_5[0]]
      [0.30 JuCol2_5[1]]
      [0.40 JuCol2_5[1]]
      [0.50 JuCol2_5[2]]
      [0.60 JuCol2_5[3]]
      [0.85 JuCol2_5[4]]
      [0.90 JuCol2_5[5]]
      [1.00 JuCol2_5[6]]
    }              
}

// Zone 3
#declare JupiterZone03Pigment=
pigment
{
    bozo
    color_map
    {
        [0.0  JuCol3[0]]
        [0.08 JuCol3[1]]
        [0.1  JuCol3[2]]
        [0.2  JuCol3[3]]
        [0.4  JuCol3[4]]
        [0.6  JuCol3[3]]
        [0.7  JuCol3[4]]
        [0.8  JuCol3[5]]
        [0.85 JuCol3[6]]
        [0.9  JuCol3[7]]
        [0.95 JuCol3[7]]
    }              
    turbulence 0.4
    scale 0.02
}

// Zone 4
#declare JupiterZone04Pigment=
pigment
{
    bozo
    color_map
    {
      [0.00 JuCol2_5[0]]
      [0.30 JuCol2_5[1]]
      [0.40 JuCol2_5[1]]
      [0.50 JuCol2_5[2]]
      [0.60 JuCol2_5[3]]
      [0.85 JuCol2_5[4]]
      [0.90 JuCol2_5[5]]
      [1.00 JuCol2_5[6]]
    }              
    turbulence 0.5
    omega 0.5
    scale <0.06,0.005,1>
}

// Zone 5
#declare JupiterZone05Pigment=
pigment
{
    bozo
    color_map
    {
      [0.00 JuCol2_5[0]]
      [0.20 JuCol2_5[1]]
      [0.30 JuCol2_5[1]]
      [0.35 JuCol2_5[2]]
      [0.40 JuCol2_5[3]]
      [0.50 JuCol2_5[4]]
      [0.70 JuCol2_5[5]]
      [1.00 JuCol2_5[6]]
    }              
    turbulence 0.5
    omega 0.3
    scale <0.06,0.06,1>
}

// Zone 7 (noticed that 6 is gone?)
#declare JupiterZone07Pigment=
pigment
{
    bozo
    color_map
    {
      [0.05 JuCol1[3]]
      [0.1  JuCol1[0]]
      [0.15 JuCol1[1]]
      [0.2  JuCol1[4]]
      [0.4  JuCol1[2]]
      [0.5  JuCol1[4]]
      [0.6  JuCol1[3]]
      [0.8  JuCol1[4]]
    }              
    turbulence 0.6
    omega 0.3
    scale <0.1,0.03,1>
}

//JupiterGrf = great red spot

// Rotation angles in degrees (position on main sphere)
#declare JuGrfRotX=-25;
#declare JuGrfRotY=-30;

// inner spiral
#declare JupiterGrfSpiralSmall =
pigment {
               spiral1 7
               sine_wave
               scale 0.1
               color_map
               {
                 [0.0 JuGrfCol[0]]
                 [0.8 JuGrfCol[1]]
                 [0.9 JuGrfCol[2]]
               }              
               frequency 1
               turbulence 0.6
}

// outer spiral
#declare JupiterGrfSpiralBig =
pigment {
               spiral1 2
               sine_wave
               scale 0.2
               color_map               
               {
                 [0.0 JuGrfCol[1]]
                 [0.8 JuGrfCol[2]]
                 [1.0 JuGrfCol[3]]
               }              
               frequency 1
               turbulence 0.2
}

// create the spot: blend spirals and covering colours
#declare JupiterGrf= 
    sphere { <0,0,0>,1
             scale <1*0.15, 0.7*0.15, 1>
             pigment 
             {             
               gradient -z
               ramp_wave 
               scale 2
               translate z*1

               pigment_map {
                   [0.45 rgbt <1,1,1,0>]
                   [0.55 JupiterGrfSpiralBig]
                   [0.90 JupiterGrfSpiralSmall]
                   [0.97 JuGrfCol[0]]
                   [1.00 JuGrfCol[0]]
                        }
               rotate -z*JuRotFast
             }
             finish 
             {
               diffuse 1
               ambient 0
               reflection 0
             }   

    scale <1,1,0.03>               
    translate -z*0.98
          
    rotate y*JuGrfRotY
    rotate y*JuRotVSlow
    rotate x*JuGrfRotX
}


// Jupiter itself
#declare Jupiter =
union
{ 
  // fake gas light scattering with fading. NOTE: will not work in backlight scenes!
  sphere { <0,0,0>,1.0001
           hollow

           interior { fade_distance 0.4
                      fade_power 2
                        
           }           
           pigment { rgbt <1,1,1,1> }
           finish { diffuse 1 }           
  }

  sphere {<0,0,0>,1

        pigment
        {
                gradient y
                scale 2
                translate y*-1
                turbulence 0.005
                omega 0.95
          
                pigment_map {
                        [0.17 JupiterPolePigment]

                        [0.19 JupiterZone01Pigment rotate y*JuRotSlow]
                        [0.20 JupiterZone01Pigment rotate y*JuRotSlow]
      
                        [0.22 JupiterZone03Pigment rotate -y*JuRotSlow]
                        [0.25 JupiterZone03Pigment rotate -y*JuRotSlow]
                        [0.27 JupiterZone01Pigment]
                        [0.28 JupiterZone01Pigment]

                        [0.30 JupiterZone05Pigment]
                        [0.32 JupiterZone02Pigment scale <0.6,1.5,1> omega 0.8 turbulence 0.7 rotate -y*JuRotSlow]
                        [0.37 JupiterZone02Pigment scale <0.6,1.5,1> omega 0.8 turbulence 0.4 rotate -y*JuRotSlow]
                        [0.38 JupiterZone05Pigment]

                        [0.40 JupiterZone07Pigment rotate -y*JuRotFast]
                        [0.46 JupiterZone07Pigment rotate -y*JuRotFast]

                        [0.49 JupiterZone05Pigment]
                        [0.51 JupiterZone02Pigment rotate -y*JuRotSlow]
                        [0.55 JupiterZone02Pigment rotate -y*JuRotSlow]
                        [0.57 JupiterZone05Pigment]

                        [0.60 JupiterZone01Pigment rotate -y*JuRotFast]
                        [0.62 JupiterZone01Pigment rotate -y*JuRotFast]
                        [0.63 JupiterZone04Pigment rotate y*JuRotVSlow]
                        [0.64 JupiterZone04Pigment rotate y*JuRotVSlow]
                        [0.65 JupiterZone01Pigment rotate -y*JuRotFast]
                        [0.68 JupiterZone01Pigment rotate -y*JuRotFast]

                        [0.70 JupiterZone03Pigment rotate y*JuRotSlow]
                        [0.78 JupiterZone03Pigment rotate y*JuRotSlow]

                        [0.80 JupiterPolePigment]
                        [1.00 JupiterPolePigment]
                }
       
                warp {
                        black_hole <-sin(JuGrfRotY), sin(JuGrfRotX), -cos(JuGrfRotX)>, 0.4
                        falloff 2
                        strength 0.5
                        inverse
                }
        }
     
        finish {
                diffuse 1.3
                ambient 0
        }
  }

  object {JupiterGrf}
  scale <1428.00,1355.00,1428.00>  // scale is 1 = 100 km
}
#end
